Subject: Re: [RFC/PATCH] powerpc: Move CPM command handling into the cpm drivers

From: Vitaly Bordug <[email-masked]>
Date: Tue, 27 Nov 2007 00:22:49 +0300

On Mon, 26 Nov 2007 10:24:46 -0600
Scott Wood wrote:

> On Fri, Nov 23, 2007 at 12:51:21AM +0300, Vitaly Bordug wrote:
> > Even that might be not enough - we may have simultaneous call of
> > this func in non-smp case...
> 
> Do you really think that every piece of code that uses spinlocks in
> the kernel is broken on non-SMP?
> 
No. I think spinlock is not universal save thing in such cases. See below.

> > I was thinking of some kind of refcount, so one that is going to
> > issue CPM command, must do say pq_cpmp_get() and another driver
> > won't be able to mangle with cpcr while it's not done with previous
> > request.
> 
> How on earth are you going to effect mutual exclusion using reference
> counting?
> 

perhaps I was not clear enough. That was a rough idea how to handle the whole thing,
not just cpm_cr_cmd. This cpm command is a corner case, but there can be other actions
that may confuse CPM being triggered simultaneously or overlapping. This is part of much bigger
problem, and I was intended to have a look what people think about that.
-- 
Sincerely, Vitaly